use actix::Addr;
use actix_web::{HttpResponse, Responder, web};

use crate::actors::users_actor::{FindUserByUsername, UsersActor};

#[derive(serde::Deserialize)]
pub struct FindUserNameReq {
    username: String,
}

#[derive(serde::Serialize)]
struct FindUserResult {
    user_id: Option<String>,
}

pub async fn find_username(req: web::Form<FindUserNameReq>, users: web::Data<Addr<UsersActor>>) -> impl Responder {
    let res = users.send(FindUserByUsername(req.0.username)).await.unwrap();
    HttpResponse::Ok().json(FindUserResult {
        user_id: res.0.map(|r| r.uid)
    })
}